(*        Editor zum Problemlosen Editieren von Disketten                   *)
(*                       Version 1.0 (c) R.S. 1989                          *)
program Disk_Editor;

type  str20 = string[20];

const HexZiffern : set of char = ['0'..'9','A'..'F'];
      AlphaZeichen : set of char = [#32..#126,#160..#254];
      HexZiffer:array[0..15] of char = '0123456789abcdef';

{$I READDISK.PAS }

var Block, ByteNr, last, MaxByte : integer;
    Eingabe : char;
    Modus : (Alpha,Hex);
    SuchZeile : string[40];
    locked : boolean;
    FileGroesse : real;
    UpperCase : boolean;
    LWname:string[3];

(*                           Hilfsprozeduren                                *)

procedure LiesZeichen(VAR c : char);   (* Ihre spezielle Anpassung fuer die *)
  begin                                (* Cursor-Tasten. Siehe Turboheft 3  *)
    read(kbd,c);
  end; (* LiesZeichen *)

procedure WarteAufESC(Meldung : str20);
  var c : char;
  begin
    write(Meldung,' <ESC>');
    repeat read(kbd,c) until c=#27
  end; (* WarteAufESC *)

function MAX(x,y:integer):integer;
  begin
    if x>y then MAX:=x else MAX:=y
  end; (* MAX *)

function MIN(x,y:integer):integer;
  begin
    if x<y then MIN:=x else MIN:=y
  end; (* MIN *)

procedure writeHex(b : byte);
  begin
    write(HexZiffer[b SHR 4],HexZiffer[b and 15])
  end; (* writeHex *)

(*                 Bildschirm-Handling und Cursor-Steuerung                 *)

procedure ShowPage;
  var i,j : integer; AlfaZeile : string[16]; b : byte; r : real;
  begin
    gotoxy(30,1);write(Block div 40:3);
    gotoxy(43,1);write((Block mod 40)+1:3);
    LongSeekDisk(128.0*Block);
    r:=FileGroesse-128.0*Block;
    if r>=256 then MaxByte:=255 else MaxByte:=trunc(r)-1;
    if locked then LowVideo;
    for i:=1 to 16 do begin
      AlfaZeile:='';
      for j:=1 to 16 do
      if (pred(i) SHL 4) OR pred(j)<=MaxByte then begin
       readDisk(b);
       if j=1 then gotoxy(1,i+2);
       writeHex(b); write(' ');
       if chr(b) in AlphaZeichen
       then AlfaZeile:=AlfaZeile+chr(b)
       else AlfaZeile:=AlfaZeile+'.';
      end
      else write('   ');
      gotoxy(53,i+2);
      write(AlfaZeile);
      NormVideo;
      ClrEol;
    end; (* FOR *)
  end; (* ShowPage *)

procedure SeiteHoch;
  begin
    if Block>0 then begin Block:=MAX(Block-2,0); ShowPage end
               else write(^G)
  end; (* SeiteHoch *)

procedure SeiteTief;
  begin
    if Block < (last-1) then begin
     Block:=MIN(Block+2,last);
     ShowPage
    end
    else write(^G)
  end; (* SeiteTief *)

procedure BDOSBlockRueck;
 begin
  Block:=Block shr DPB^.BSH;
  Block:=Block shl DPB^.BSH;
  if Block>0 then begin
   Block:=MAX(Block-(DPB^.BLM+1),0);
   ShowPage
  end
  else write(^G);
 end;

procedure BDOSBlockVor;
 begin
  Block:=Block shr DPB^.BSH;
  Block:=Block shl DPB^.BSH;
  if Block < (last-DPB^.BLM) then begin
    Block:=MIN(Block+DPB^.BLM+1,last);
    ShowPage
  end
  else write(^G)
 end;

procedure ChangeModus;
  begin
    if Modus=Hex then Modus:=Alpha else Modus:=Hex;
    gotoxy(16,1); if Modus=Alpha then write('Alpha') else write('Hex  ')
  end; (* ChangeModus *)


procedure HauptBildschirm;
  begin
    ClrScr; LowVideo; write('FILE:');
    gotoxy(10,1); write('MODUS:'); gotoxy(25,1); write('TRACK:');
    gotoxy(35,1); write('SECTOR:');
    gotoxy(50,1); write('BYTE:'); gotoxy(63,1); write('GESAMT:');
    NormVideo;
    gotoxy(7,1); write(LWname);
    gotoxy(71,1); write(succ(last));
    Modus:=Alpha; ChangeModus; LowVideo;
    gotoxy(1,20); writeln('Kommandos:');
    writeln('  Byte   Seite  Zeile  BDOSblk |  ^QU Schreibschutz ein/aus  ');
    writeln('   ^E     ^QR            ^W    |  ^QF Suchen / ^L Wiederholen');
    writeln(' ^H + ^D   |   ^A--^F     |    |  ^V  Modus Hex/ASCII        ');
    write  ('   ^X     ^QC            ^Z    |  ESC ENDE                   ');
    NormVideo
  end; (* HauptBildschirm *)

(*                        Editieren und Suchen                              *)


procedure LiesByte;
  label EXIT;
  var z : char; b : byte; t,fc : integer;
  begin
    case Modus of
      Alpha : b:=ord(Eingabe);
      Hex   : begin
               Eingabe:=upcase(Eingabe);
               if not (Eingabe in HexZiffern)
                 then begin write(^G); goto EXIT end
                 else begin
                   write(Eingabe);
                   repeat
                    read(kbd,z); z:=upcase(z)
                   until z in HexZiffern+[#27];
                   if z=#27
                   then begin
                    LongSeekDisk(128.0*Block+ByteNr);
                    readDisk(b)
                   end
                   else begin val('$'+Eingabe+z,t,fc); b:=LO(t) end
                 end (* ELSE *)
              end (* BEGIN *)
    end; (* CASE *)
    LongSeekDisk(128.0*Block+ByteNr); writeDisk(b);
    gotoxy(1+(ByteNr AND 15)*3,3+(ByteNr SHR 4)); writeHex(b);
    gotoxy(53+(ByteNr AND 15),3+(ByteNr SHR 4));
    if chr(b) in AlphaZeichen then write(chr(b)) else write('.');
    ByteNr:=succ(ByteNr);
    EXIT:
  end; (* LiesByte *)

procedure Suche(neu:boolean); (* Sucht nach STRING oder BYTE-Folge *)
  label EXIT;
  var Position, Laenge, FehlerCode, Seite : integer;
      gefunden, ShowFlag, Fehler : boolean;
      BytePosition : real;
      temp : string[40];
      c : char; i : integer;
      AnfangsByte, SuchByte, VergleichsByte : byte;

  procedure KonvertHexLine(VAR Fehler : boolean);
    var HexLine : string[20];
        HexZahl : integer;
    begin
      temp:=SuchZeile;
      while pos(' ',temp)>0 do delete(temp,pos(' ',temp),1);
      HexLine:=''; Fehler:=false;
      while (length(temp)>1) and (not Fehler) do begin
       val('$'+copy(temp,1,2),HexZahl,FehlerCode);
       Fehler:=FehlerCode<>0; HexLine:=HexLine+chr(LO(HexZahl));
       delete(temp,1,2)
      end; (* WHILE *)
      if temp<>'' then Fehler:=true;
      temp:=HexLine; Laenge:=length(temp)
    end; (* KonvertHexLine *)

  begin (* suche *)
    gotoxy(1,2); LowVideo;
    if Modus=Alpha then write('Suchbegriff: ') else write('Bytefolge: ');
    NormVideo;
    if neu then begin
      read(SuchZeile);
      if Modus=Alpha then begin
        write(' Gross/Klein-unterscheiden? ');
        repeat read(kbd,c); c:=upcase(c) until (c='J') or (c='N');
        UpperCase:=c='N';
        if UpperCase then for i:=1 to length(SuchZeile) do
         SuchZeile[i]:=upcase(SuchZeile[i]);
        gotoxy(14,2); write(SuchZeile); ClrEol
      end
    end
    else write(SuchZeile);
    if SuchZeile='' then goto EXIT else Laenge:=length(SuchZeile);
    ShowFlag:=false; Fehler:=false; gefunden:=false;
    if Modus=Alpha
      then temp:=SuchZeile
      else if SuchZeile[1]='=' then begin
        val(copy(suchZeile,2,Laenge-1),Seite,FehlerCode);
        if (FehlerCode=0) and (Seite<=succ(last)) and (Seite>0) then begin
          ShowFlag:=true; Block:=Seite-1; goto EXIT
        end
        else begin WarteAufESC(' ???'); goto EXIT end
      end
      else KonvertHexLine(Fehler);
    if Fehler then begin WarteAufESC(' ???'); goto EXIT end;
    BytePosition:=128.0*Block+ByteNr; LongSeekDisk(BytePosition);
    Position:=1; AnfangsByte:=ord(temp[Position]);
    VergleichsByte:=AnfangsByte;
    while (not EOFDisk) and (not gefunden) do begin
        if keypressed then begin
            read(kbd,c);
            if c=^U then
              begin
               gotoxy(40,2);
               WarteAufESC(' ABBRUCH!'); goto EXIT end
          end; (* IF *)
        readDisk(SuchByte);
        if UpperCase then SuchByte:=ord(upcase(chr(SuchByte)));
        if SuchByte=VergleichsByte
          then if Position=Laenge then gefunden:=true
                 else begin
                        Position:=succ(Position);
                        VergleichsByte:=ord(temp[Position])
                       end
          else if Position>1 then begin
                        LongSeekDisk(LongFilePosDisk+1-Position);
                        Position:=1;
                        VergleichsByte:=AnfangsByte
                      end
      end; (* WHILE *)
    if gefunden then begin
             BytePosition:=LongFilePosDisk;
             Seite:=trunc(BytePosition/128);
             ByteNr:=trunc(BytePosition-128.0*Seite);
             if Block=(Seite-1)
               then ByteNr:=ByteNr+128
               else if Block<>Seite then begin
                ShowFlag:=true;
                Block:=Seite;
                if (Block mod 2)=1 then begin
                 Block:=Block-1;
                 ByteNr:=ByteNr+128;
                end;
               end;
             if Block>last then begin Block:=last; ByteNr:=127 end;
             if Block=last then if last>0
               then begin Block:=pred(Block); ByteNr:=128+ByteNr end
           end (* IF...THEN *)
      else WarteAufESC(' ... nicht gefunden');
    EXIT: gotoxy(1,2); ClrEol; if ShowFlag then ShowPage
  end; (* suche *)

procedure HoleZeichen(erstes : char; var c : char);
  begin
    gotoxy(1,1); LowVideo; write('^',erstes,'   '); gotoxy(3,1);
    read(kbd,c);
    gotoxy(1,1); write('DISK:'); NormVideo
  end; (* HoleZeichen *)

procedure Lock_Unlock; (* Macht ein Veraendern der Datei unmoeglich *)
  begin
    locked:=not locked; gotoxy(21,1);
    if locked then write('/L') else write('  '); ShowPage;
  end; (* Lock_Unlock *)

procedure Ctrl_Q_Menue;
  var Auswahl : char;

  procedure ZumAnfang;
    begin
      Block:=0; ByteNr:=0; ShowPage
    end; (* ZumAnfang *)

  procedure ZumEnde;
    begin
      Block:=MAX(last-1,0); ShowPage; ByteNr:=MaxByte
    end; (* ZumEnde *)

  begin (* Ctrl_Q_Menue *)
    HoleZeichen('Q',Auswahl);
    case upcase(Auswahl) of
      ^R, 'R' : ZumAnfang;
      ^C, 'C' : ZumEnde;
      ^F, 'F' : Suche(true);
      ^U, 'U' : Lock_Unlock
    end
  end;

(*                        Das Hauptprogramm                                 *)

BEGIN
  IF ParamCount=0 THEN BEGIN
   write('LW : ');
   readln(lwname);
   for bytenr:=1 to length(lwname) do lwname[bytenr]:=upcase(lwname[bytenr]);
  end
  else lwname:=Paramstr(1);
  assignDisk(lwname);  ResetDisk;
  IF IOResultDisk<>0 THEN BEGIN writeln('Keine Disk!'); halt END;
  FileGroesse:=LongFileSizeDisk;
  last:=pred(trunc(FileGroesse/128)); Block:=0; ByteNr:=0;
  SuchZeile:=''; locked:=false; cbreak:=false;
  HauptBildschirm; Lock_Unlock;
  REPEAT
    IF ByteNr<0
      THEN IF Block>0 THEN BEGIN SeiteHoch; ByteNr:=256+ByteNr END
                      ELSE BEGIN ByteNr:=0; write(^G) END;
    IF ByteNr>MaxByte
      THEN IF MaxByte<255 THEN BEGIN ByteNr:=MaxByte; write(^G) END
                          ELSE BEGIN SeiteTief; ByteNr:=ByteNr AND 255 END;
    gotoxy(56,1); writehex(succ(ByteNr)-1);
    IF Modus=Hex THEN gotoxy(1+(ByteNr AND 15)*3,3+(ByteNr SHR 4))
                 ELSE gotoxy(53+(ByteNr AND 15),3+(ByteNr SHR 4));
    LiesZeichen(Eingabe);
    CASE Eingabe OF
      ^D : ByteNr:=succ(ByteNr);
      ^H,^S : ByteNr:=pred(ByteNr);
      ^X : ByteNr:=ByteNr+16;
      ^E : ByteNr:=ByteNr-16;
      ^R : SeiteHoch;
      ^C : SeiteTief;
      ^A : ByteNr:=ByteNr AND $F0;
      ^F : ByteNr:=ByteNr OR 15;
      ^V : ChangeModus;
      ^Q : Ctrl_Q_Menue;
      ^L : Suche(false);
      ^W : BDOSBlockRueck;
      ^Z : BDOSBlockVor;
    #$1b : ;
      ELSE IF Eingabe>=#32 THEN IF NOT locked THEN LiesByte ELSE write(^G)
    END
  UNTIL Eingabe=#$1b;
  CloseDisk; ClrScr
END. (* Disk_Editor *)

