const MaxBytePuffer = 1024;
type lw_str14 = string[14];
var    Disk : record
                  Puffer : array[1..MaxBytePuffer] of byte;
                  Ptr, Erster, Letzter, Size : integer;
                  WriteFlag : boolean;
                end;
TYPE DPBTYP   = ^DPBSTRUC;
     DPBSTRUC = record
                 SPT : integer;
                 BSH : byte;
                 BLM : byte;
                 EXT : byte;
                 DSM : integer;
                 DRM : integer;
                 AL0 : byte;
                 AL1 : byte;
                 CKS : integer;
                 OFF : integer;
               end;
VAR   DPB  : DPBTYP;
      DPBi : integer absolute DPB;
      IOResultDisk : integer;
      LW           : byte;

procedure BlockReadDisk(var p;Nr,l:integer);
 var i:integer;
 begin
  if l>0 then begin
   NR:=NR-1;
   for i:=0 to l-1 do begin
    BIOS(11,Addr(p)+i*128); { SET DMA }
    BIOS(10,(Nr mod 40)+1);
    BIOS(9,Nr div 40);
    BIOS(12);               { Read }
    Nr:=Nr+1;
   end;
  end;
 end;

procedure BlockWriteDisk(var p;Nr,l:integer);
 var i:integer;
 begin
  for i:=0 to l-1 do begin
   BIOS(11,Addr(p)+i*128); { SET DMA }
   BIOS(10,Nr mod 40);
   BIOS(9,Nr div 40);
   BIOS(13);               { Write }
   BIOS(8,LW);
   Nr:=Nr+1;
  end;
 end;


procedure LiesBlock(Nr : integer);
  function MIN(x,y : integer):integer;
    begin if x<y then MIN:=x else MIN:=y end;
  begin
    with Disk do
      begin
        Erster:=Nr; Ptr:=0;
        Letzter:=Nr+MIN(Size-Nr,pred(MaxBytePuffer SHR 7));
        blockreadDisk(Puffer,Nr,succ(Letzter-Erster));
      end  (* WITH *)
  end; (* LiesBlock *)

procedure FlushDisk;
  begin
    with Disk do
      if WriteFlag then
        begin
          blockwriteDisk(Puffer,erster,succ(Letzter-Erster));
          WriteFlag:=false
        end (* IF *)
  end; (* FlushDisk *)

procedure LongSeekDisk(Position : real);
  var Seite, Nummer : integer;
  begin
    Seite:=trunc(Position/128); Nummer:=trunc(Position-128.0*Seite);
    Seite:=succ(Seite);
    with Disk do
      if (Seite>=Erster) AND (Seite<=Letzter)
        then Ptr:=((Seite-Erster) SHL 7) OR Nummer
        else begin FlushDisk; LiesBlock(Seite); Ptr:=Nummer end;
  end; (* LongSeekDisk *)

function LongFilePosDisk : real;
  begin
    with Disk do LongFilePosDisk:=128.0*pred(Erster)+Ptr
  end; (* LongFilePosDisk *)

function EOFDisk:boolean;
  begin
    with Disk do
      EOFDisk:=(Letzter=Size) AND (Ptr=succ(Letzter-Erster) SHL 7)
  end; (* EOFDisk *)

function LongFileSizeDisk : real;
  begin
    LongFileSizeDisk:=Disk.Size*128.0;
  end; (* LongFileSizeDisk *)

procedure assignDisk( Name : lw_str14);
  begin
    LW:=byte(name[1]) and $0F;
    LW:=LW-1;

  end; (* assignDisk *)

procedure resetDisk;
  var lwResult:byte;
      i,j:integer;
  begin
   with Disk do begin
    letzter:=0; WriteFlag:=false;
    if (LW<0) or (LW>15) then begin
      Writeln(^G'Keine Disk!');
      Halt;
    end;
    lwResult:=BIOS(8,LW);
    IOResultDisk:=$FFFF;
    if LWResult<>0 then begin
      IOResultDisk:=0;
      DPBI:=BDOSHL(31);
      with DPB^ do begin
       Size:=(DSM+1)*((BLM+1) shr 3)*8+(OFF*SPT);
      end;
      LongSeekDisk(0);
    end; (* IF *)
   end;
  end; (* resetDisk *)

procedure readDisk( VAR B : byte);
  begin
    with Disk do
      begin
        if Ptr=MaxBytePuffer
          then begin
           FlushDisk;
           LiesBlock(succ(Letzter));
           gotoxy(30,1);write((letzter+1) div 40:3);
           gotoxy(43,1);write(((letzter+1) mod 40)+1:3);
          end;
        Ptr:=succ(Ptr); B:=Puffer[Ptr]
      end  (* WITH *)
  end; (* readDisk *)

procedure writeDisk( B : Byte);
  function MAX(x,y:integer):integer; begin if x>y then MAX:=x else MAX:=y end;
  begin
    with Disk do
      begin
        if Ptr=MaxBytePuffer then
          begin FLushDisk; Erster:=succ(Letzter); Ptr:=0 end;
        Ptr:=succ(Ptr); Puffer[Ptr]:=B;
        Letzter:=MAX(Letzter,Erster+(pred(Ptr) SHR 7));
        WriteFlag:=true; Size:=MAX(Size,Letzter)
      end  (* WITH *)
  end; (* writeDisk *)

procedure closeDisk;
  begin
    FlushDisk;
    BIOS(8,lw)
  end; (* closeDisk *)

